﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.9
@EndOfDesignText@
#Event: ChangeValue (Value As Boolean, UsersChange As Boolean) ' Only 2 state 
#Event: ChangeNumericValue (Value As Int, UsersChange As Boolean) ' 3 State - 0-off; 1-middle; 2-on
#DesignerProperty: Key: Value, DisplayName: Value, FieldType: Boolean, DefaultValue: False, Description: Value of Switch
#DesignerProperty: Key: Thirdstate, DisplayName: Third state, FieldType: Boolean, DefaultValue: False, Description: Third state - Value of Switch
#DesignerProperty: Key: Horizzontal, DisplayName: Horizzontal, FieldType: Boolean, DefaultValue: True, Description: Horizzontal or Vertical mode
#DesignerProperty: Key: Style, DisplayName: Style of switch, FieldType: String, DefaultValue: Vintage, List: Vintage|Classic|Modern

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private im As B4XView
	Private Pa As B4XView
	Private nValue As Int = 0
	Private Thirdstate As Boolean = False
	Private Horiz As Int = 0
	Private Style As String = "Vintage"
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	Dim ix As ImageView
	ix.Initialize("")
	im=ix
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
	mBase.Tag = Me
  	
	If True=Props.Get("Value") Then nValue=2
	Thirdstate=Props.Get("Thirdstate")
	If False=Props.Get("Horizzontal") Then Horiz=90
	If Props.ContainsKey("Style") Then Style=Props.Get("Style")

	Pa=xui.CreatePanel("switch")
	Pa.Color=xui.Color_Transparent
	mBase.AddView(im,0,0,mBase.Width,mBase.Height)
	mBase.AddView(Pa,0,0,mBase.Width,mBase.Height)
	Draw
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	im.Width=Width
	im.Height=Height
	Pa.Width=Width
	Pa.Height=Height
End Sub


Public Sub GetBase As B4XView
	Return mBase
End Sub

Public Sub setValue(B As Boolean)
	If B Then nValue=2 Else nValue=0
	If xui.SubExists(mCallBack,mEventName & "_ChangeValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeValue",b,True)
	If xui.SubExists(mCallBack,mEventName & "_ChangeNumericValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeNumericValue",nValue,True)
	Draw
End Sub

Public Sub	getValue As Boolean
	Return (nValue=2)
End Sub

' 0-off; 1-middle; 2-on
Public Sub setintValue(n As Int)
	nValue=Min(Max(0,n),2)
	Dim vl As Boolean= (nValue=2)
	If xui.SubExists(mCallBack,mEventName & "_ChangeValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeValue",vl,True)
	If xui.SubExists(mCallBack,mEventName & "_ChangeNumericValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeNumericValue",nValue,True)
	Draw
End Sub

Public Sub	getintValue As Int
	Return nValue
End Sub

Public Sub setThirdstateValue(B As Boolean)
	Thirdstate=b
End Sub

Public Sub	getThirdstateValue As Boolean
	Return Thirdstate
End Sub

#if B4J
Private Sub switch_MouseClicked (EventData As MouseEvent)
	If Thirdstate Then 
		nValue=((nValue+1) Mod 3)
	Else
		nValue=(2-nValue)
	End If
	
	Dim vl As Boolean= (nValue=2)
	If SubExists(mCallBack,mEventName & "_ChangeValue") Then CallSub3(mCallBack,mEventName & "_ChangeValue",vl,True)
	If SubExists(mCallBack,mEventName & "_ChangeNumericValue") Then CallSub3(mCallBack,mEventName & "_ChangeNumericValue",nValue,True)
	Draw
End Sub
#else
Private Sub switch_Click
	If Thirdstate Then 
		nValue=((nValue+1) Mod 3)
	Else
		nValue=(2-nValue)
	End If
	
	Dim vl As Boolean= (nValue=2)
	If xui.SubExists(mCallBack,mEventName & "_ChangeValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeValue",vl,True)
	If xui.SubExists(mCallBack,mEventName & "_ChangeNumericValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeNumericValue",nValue,True)
	Draw
End Sub
#End If


Private Sub Draw
	Dim imgfile() As String =Regex.Split(",","off.png,onf.png,on.png")

	im.SetBitmap(xui.LoadBitmap(File.DirAssets, Style.SubString2(0,2).ToLowerCase & imgfile(nValue)).Rotate(Horiz).Resize(im.Width,im.Height,False))
End Sub
